#include <stdio.h>
#include "tine.h"
#include "tbufsrv.h"

#define NPOINTS 1024
#define NCURVES 10
float sinbuf[NCURVES][NPOINTS];
float ampl[NCURVES] = { 100.0,100.0,100.0,100.0,100.0,100.0,100.0,100.0,100.0,100.0  };
float freq[NCURVES] = { 1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0  };;
float noise[NCURVES] = { 10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0  };;
float phase[NCURVES];
float damp[NCURVES]= { 10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0,10.0  };;

int amplHndlr(char *prp, char *dev, void *ref)
{
    int cc,devnr;
    float val; // warning: cast to (BYTE *)
    if ((cc = pullBufferedData(prp, dev, (BYTE *)&val, 1)) != 0) return cc;
    // maybe do some range checking, etc. and decide to accept or reject ...
    devnr =  GetBufferIndex(prp,dev); 
    ampl[devnr] = val;
    // push the value back if accepted ...
    if ((cc = pushBufferedData(prp, dev, (BYTE *)&val, 1, FALSE)) != 0) return cc;
    return 0; 
}
void updateSine(int devnr)
{ /* used internally -> don't bother with bounds checking */
  float *target = sinbuf[devnr];
  int i, k;
  float f = freq[devnr];
  int n = MAX((int)noise[devnr],1); 
  int p = (int)phase[devnr];
  float a = ampl[devnr]; 
  float d = damp[devnr]/(float)100.0; 
  char dev[64];
  for (i=0; i<NPOINTS; i++)
  {
    k = (i + p) % NPOINTS;
    target[k] = (float)(rand()%n) + (float)(sin(f*i*6.2832/(NPOINTS/8))*a);
    if (d > 0.0)
    {
      target[k] *= ((float)1.0 - (d * (float)i)/(float)NPOINTS);
    }
  }
  sprintf(dev,"SineDevice%d",devnr); 
  pushBufferedData("Sine",dev,(BYTE *)target,NPOINTS,FALSE);
  return;
}

void update(void)
{
  int i;
  for (i=0; i<NCURVES; i++) updateSine(i);
}

int main(int argc,char *argv[])
{
  char c;
  AttachServerEx(NULL,NULL,0,update,500);

  pushBufferedData("Amplitude", "#0", (BYTE *)ampl, 10, FALSE);
  RegisterServerCallbackEx("Amplitude",amplHndlr,ampl); 

  SystemWaitCycleTimer();
  return 0;
}
